#include <bits/stdc++.h>
using namespace std;

vector<long long> graph[100005];
bool isExit[100005];
long long e[100005];

bool visited[100005];

int main()
{
    long long n, m;
    cin >> n >> m;
    for(long long i = 0; i < m; ++i){
        long long x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }
    long long a;
    cin >> a;
    for(long long i = 0; i < a; ++i){
        cin >> e[i];
        isExit[e[i]] = true;
    }
    long long k;
    cin >> k;

    for(long long i = 1; i <= n; ++i){
        sort(graph[i].begin(), graph[i].end());
    }

    for(long long i = 1; i <= n; ++i){
        for(long long j = 1; j <= n; ++j){
            visited[i] = false;
        }

        queue<long long> q;
        q.push(i);
        visited[i] = true;
        vector<long long> sol;
        long long closed = 0;
       // bool found = false;

        while(!q.empty()){
            long long v = q.front();
            q.pop();

            if(isExit[v]){
                if(closed == k){
                    sol.push_back(v);
                    break;
                }else{
                    closed++;
                }
            }

            for(auto u : graph[v]){
                if(!visited[u]){
                    visited[u] = true;
                    q.push(u);
                }
            }
        }

        if(sol.empty()){
            cout << "-1 ";
        }else{
            cout << *min_element(sol.begin(), sol.end()) << " ";
        }
    }


    return 0;
}