#include <bits/stdc++.h>
using namespace std;

//trie

pair<long long, long long> trie[100005][30];
long long nd[100005][30];

long long sz = 0;

void addWord(string str){
    long long n = str.size();
    long long cur = 0;

    for(long long i = 0; i < n; ++i){
        long long c = str[i] - 'a';

        if(trie[cur][c].first != 0){
            trie[cur][c].second++;
            if(i == n - 1){
                nd[cur][c]++;
            }
        }else{
            trie[cur][c].first = ++sz;
            trie[cur][c].second = 1;
            if(i == n - 1){
                nd[cur][c]++;
            }
        }

        cur = trie[cur][c].first;
    }
}

long long getLess(long long cur, long long ind, string str){
    long long n = str.size();
    if(ind == n){
        return 0;
    }

    long long res = 0;
    for(long long i = 0; i < (str[ind] - 'a'); ++i){
        res += trie[cur][i].second;
    }

    res += nd[cur][str[ind] - 'a'];

    if(trie[cur][(str[ind] - 'a')].first != 0){
        res += getLess(trie[cur][(str[ind] - 'a')].first, ind + 1, str);
    }

    return res;
}

bool exists(string str){
    long long n = str.size();
    long long cur = 0;

    for(long long i = 0; i < n; ++i){
        long long c = str[i] - 'a';

        if(trie[cur][c].first != 0){
            cur = trie[cur][c].first;
        }else{
            return false;
        }
    }

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    long long t;
    cin >> t;
    while(t--){
        string com, str;
        cin >> com >> str;

        long long n = str.size();
        for(long long i = 0; i < n; ++i){
            str[i] = tolower(str[i]);
        }

        if(com == "INSERT"){
            if(!exists(str)){
                addWord(str);
            }
        }else{
            if(!exists(str)){
                cout << "NA\n";
            }else{
                long long x = getLess(0, 0, str) - 1;///this returns <=, so -1
                cout << x << "\n";
            }
        }
    }

    return 0;
}

/*
10

INSERT aa
INSERT migg
INSERT mjgg
INSERT mkgg
LESS aa
LESS migg
LESS mjgg
INSERT mjgz
LESS mkgg
LESS mjgz


3
INSERT aa
INSERT aaa
LESS aaa
*/