#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n;
long long zbir = 0;
vector <bool> nizBoolova(n);
vector <int> v;

void stampaj()
{
    for(int i = 0; i < n; i++)
    {
        cout << nizBoolova[i] << endl;
    }
}

long long izracunaj()
{
    int brojac = 0;
    int najmanji = INT_MAX;
    int najveci = INT_MIN;

    //stampaj();

    for(int j = 0; j < n; j++)
    {
        if(nizBoolova[j] == true)
        {
            brojac++;

            if(v[j] > najveci)
            {
                najveci = v[j];
            }

            if(v[j] < najmanji)
            {
                najmanji = v[j];
            }
        }
    }

    if(brojac == 0)
    {
        return 0;
    }

    return najmanji * najveci * brojac;
}

void rekurzija(int i)
{
    if(i == n)
    {
        zbir += izracunaj();
        return;
    }

    v[i] = false;
    rekurzija(i + 1);
    v[i] = true;
    rekurzija(i + 1);
}

int main()
{

cin >> n;

for(int i = 0; i < n; i++)
{
    int broj;

    cin >> broj;

    v.push_back(broj);
    //nizBoolova[i] = false;
}

//sort(v.begin(), v.end());

rekurzija(0);

cout << zbir;

    return 0;
}