#include <bits/stdc++.h>

#define len 100000

using namespace std;

vector<int> graph[len];

int bfs(int exit[], int src, int n, int k, int a) {

    queue<int> q;
    bool visited[n];
    int dist[n];

    for(int i = 0; i < n; i++)
        visited[i] = false, dist[i] = INT_MAX;

    q.push(src);
    visited[src] = true;
    dist[src] = 0;

    int br = 1;
    while(!q.empty()) {
        int temp = q.front();
        q.pop();

        for(int x:graph[temp]) {
            if(visited[x])
                continue;
            q.push(x);
            visited[x] = true;
            dist[x] = br;
        }
        br++;
    }

    pair<int, int> niz[a];
    for(int i = 0; i < a; i++)
        niz[i] = make_pair(dist[exit[i]], exit[i]);

    sort(niz, niz + a);

    for(int i = 0; i < a; i++) {
        if(niz[i].first == INT_MAX)
            return -1;
        if(k == 0)
            return niz[i].second + 1;
        k--;
    }

    return -1;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;

        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    int a;
    cin >> a;
    int exit[a];
    for(int i = 0; i < a; i++) {
        cin >> exit[i];
        exit[i]--;
    }

    int k;
    cin >> k;

    for(int i = 0; i < n; i++)
        cout << bfs(exit, i, n, k, a) << " ";

    cout << endl;
    return 0;
}