#include <bits/stdc++.h>

#define ll long long
#define len 100000

using namespace std;

vector<int> graph[len];

ll bfs(ll exit[], ll src, ll n, ll k, ll a) {

    queue<ll> q;
    bool visited[n];
    ll dist[n];

    for(ll i = 0; i < n; i++)
        visited[i] = false, dist[i] = INT_MAX;

    q.push(src);
    visited[src] = true;
    dist[src] = 0;

    int br = 1;
    while(!q.empty()) {
        ll temp = q.front();
        q.pop();

        for(ll x:graph[temp]) {
            if(visited[x])
                continue;
            q.push(x);
            visited[x] = true;
            dist[x] = br;
        }
        br++;
    }

    pair<ll, ll> niz[a];
    for(ll i = 0; i < a; i++)
        niz[i] = make_pair(dist[exit[i]], exit[i]);

    sort(niz, niz + a);

    for(ll i = 0; i < a; i++) {
        if(niz[i].first == INT_MAX)
            return -1;
        if(k == 0)
            return niz[i].second + 1;
        k--;
    }

    return -1;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n, m;
    cin >> n >> m;

    for(ll i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        --a;
        --b;

        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    ll a;
    cin >> a;
    ll exit[a];
    for(ll i = 0; i < a; i++) {
        cin >> exit[i];
        exit[i]--;
    }

    ll k;
    cin >> k;

    for(ll i = 0; i < n; i++)
        cout << bfs(exit, i, n, k, a) << " ";

    cout << endl;
    return 0;
}