#include <iostream>
#include <queue>
#include <vector>
#include <algorithm>

#define CTASK tasks.top()
//#define FEEDBACK

using namespace std;

class soba{
public:
    bool exit;
    vector<int> hodnici;
    void zavrsi();
    void dodajHodnik(int soba2);
};

int main()
{
    queue<int> tasks;
    int n, m, e, k;
    int a, b;
    cin >> n >> m;
    vector<soba> bunker(n);
    for(int i = 0; i < m; ++i){
        cin >> a >> b;
        bunker[a-1].dodajHodnik(b-1);
        bunker[b-1].dodajHodnik(a-1);
    }
    for(int i = 0; i < n; ++i){
        bunker[i].zavrsi();
    }
    cin >> e;
    for(int i = 0 ; i < e; ++i){
        cin >> a;
        bunker[a-1].exit = true;
    }
    cin >> k;
    int kpr;
    int s = bunker.size();
    vector<bool> bvec(s);
    for(int i = 0; i < n; ++i){
        kpr = k;
        for(int i = 0; i < s; ++i){
            bvec[i] = false;
        }
        while(tasks.size() > 0){
            tasks.pop();
        }
        int brh;
        tasks.push(i);
        int ctask;
        while(tasks.size() > 0){
            ctask = tasks.front();
            if(!bvec[ctask]){
#ifdef FEEDBACK
                cout << "dfs" << i << ".ctask = " << ctask << ";\n";
#endif // FEEDBACK
                bvec[ctask] = true;
                if(bunker[ctask].exit){
                    if(kpr == 0){
                        cout << ctask + 1 << " ";
                        break;
                    }
                    else{
                        --kpr;
                    }
                }
                brh = bunker[ctask].hodnici.size();
                for(int i = 0; i < brh; ++i){
                    tasks.push(bunker[ctask].hodnici[i]);
                }
            }
            tasks.pop();
        }
        if(tasks.size() == 0){
            cout << -1 << " ";
        }
    }
    cout << endl;
    return 0;
}

void soba::zavrsi(){
    sort(hodnici.begin(), hodnici.end());
    exit = false;
}

void soba::dodajHodnik(int soba2){
    hodnici.push_back(soba2);
}