#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

//#define FEEDBACK

using namespace std;

void Insert(vector<string>& vec, string str);
void Less(const vector<string>& vec, vector<int>& res, string str);

int main()
{
    int n;
    cin >> n;
    vector<string> vec;
    vector<int> res;
    vec.reserve(n);
    res.reserve(n);
    string command, par;
    for(int i = 0; i < n; ++i){
        cin >> command >> par;
        if(command == "insert"){
            Insert(vec, par);
#ifdef FEEDBACK
            for(int i = 0; i < vec.size(); ++i){
                cout << vec[i] << " ";
                cout << endl;
            }
#endif // FEEDBACK
        }

        else{
            Less(vec, res, par);
#ifdef FEEDBACK
            cout << res.back() << endl;
#endif // FEEDBACK
        }
    }
    int s = res.size();
    for(int i = 0; i < s; ++i){
        if(res[i] == -1){
            cout << "NA" << endl;
        }
        else{
            cout << res[i] << endl;
        }
    }
    return 0;
}

void Insert(vector<string>& vec, string str){
    int s = str.size();
    for(int i = 0 ; i < s; ++i){
        if(str[i] <= 'Z'){
            str[i] += 'a' - 'A';
        }
    }
    int min = 0;
    int max = vec.size()-1;
    int mid = (min + max)/2;
    while(min <= max){
        if(vec[mid] == str){
            return;
        }
        if(vec[mid] < str){
            min = mid + 1;
            mid = (min + max)/2;
        }
        else{
            max = mid - 1;
            mid = (min + max)/2;
        }
    }
    vec.insert(vec.begin() + min, str);
}
void Less(const vector<string>& vec, vector<int>& res, string str){
    int s = str.size();
    for(int i = 0 ; i < s; ++i){
        if(str[i] <= 'Z'){
            str[i] += 'a' - 'A';
        }
    }
    int min = 0;
    int max = vec.size()-1;
    int mid = (min + max)/2;
    while(min <= max){
        if(vec[mid] == str){
            res.push_back(mid);
            return;
        }
        if(vec[mid] < str){
            min = mid + 1;
            mid = (min + max)/2;
        }
        else{
            max = mid - 1;
            mid = (min + max)/2;
        }
    }
    res.push_back(-1);
}