#include <bits/stdc++.h>
using namespace std;

vector<int> graph[100005];
bool isExit[100005];
int e[100005];

bool visited[100005];

int main()
{
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }
    int a;
    cin >> a;
    for(int i = 0; i < a; ++i){
        cin >> e[i];
        isExit[e[i]] = true;
    }
    int k;
    cin >> k;

    for(int i = 1; i <= n; ++i){
        sort(graph[i].begin(), graph[i].end());
    }

    for(int i = 1; i <= n; ++i){
        for(int i = 1; i <= n; ++i){
            visited[i] = false;
        }

        queue<int> q;
        q.push(i);
        visited[i] = true;

        int closed = 0;
        //bool found = false;

        vector<int> sols;

        while(!q.empty()){
            int v = q.front();
            q.pop();

            if(isExit[v]){
                if(closed == k){
                    sols.push_back(v);
                }else{
                    closed++;
                }
            }

            for(auto u : graph[v]){
                if(!visited[u]){
                    visited[u] = true;
                    q.push(u);
                }
            }
        }

        if(!sols.size()){
            cout << "-1 ";
        }else{
            cout << *min_element(sols.begin(), sols.end()) << " ";
        }
    }

    cout << "\n";
    return 0;
}