#include<bits/stdc++.h>
using namespace std;

const int N = (int) 1e5 + 10;

struct komp {
    bool operator()(const pair<int, int>& A, const pair<int, int>& B) {
        if(A.first < B.first)
            return false;
        if(A.first > B.first)
            return true;
        return A.second > B.second;
    }
};
priority_queue<pair<int, int>, vector<pair<int, int> >, komp> cvor;
int n, m, l, k, brojac, poslCvor;
vector<int> graf[N];
bool asoc[N];

int bfs(bool pos[]) {
    while(!cvor.empty()) {
        if(brojac < 0)
            return poslCvor;
        pair<int, int> par = cvor.top();
        cvor.pop();
        int trenCvor = par.second;
        if(pos[trenCvor])
            continue;
        pos[trenCvor] = true;
        int veci = 0;
        if(asoc[trenCvor]) {
            --brojac;
            poslCvor = trenCvor;
            veci = 1;
        }
        for(int i = 0; i < graf[trenCvor].size(); ++i) {
            cvor.emplace(make_pair(par.first + veci, graf[trenCvor][i]));
        }

    }
    return -1;
}
int bffs(int node) {
    bool pos[N] = {0};
    brojac = k;
    poslCvor = -1;
    while(!cvor.empty())
        cvor.pop();
    cvor.emplace(make_pair(0, node));
    return bfs(pos);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m;
    for(int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        graf[u].push_back(v);
        graf[v].push_back(u);
    }
    cin >> l;
    for(int i = 0; i < l; ++i) {
        int x; cin >> x;
        asoc[x] = true;
    }
    cin >> k;
    for(int i = 1; i <= n; ++i) {
        int p = bffs(i);
        cout << p << ' ';
    }
}