#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
const int maxN = 720;
ll h[maxN][maxN];
ll v[maxN][maxN];
int g[maxN][maxN];
bool pos[maxN][maxN];
int zauzeto = 1;
int n;

const int dx[] = {0, 1, 0, -1};
const int dy[] = {-1, 0, 1, 0};
queue<pair<int, int> > q;
int clanovaGrupe[10000000];


void grupe() {
    while(!q.empty()) {
        pair<int, int> par = q.front();
        q.pop();
        int i = par.first;
        int j = par.second;

        if(pos[i][j])
            continue;

        pos[i][j] = true;

        for(int p = 0; p < 4; ++p) {
            int ni = i + dy[p];
            int nj = j + dx[p];
            if(v[ni][nj] == v[i][j] && h[ni][nj] == h[i][j]) {
                g[i][j] = zauzeto;
                ++clanovaGrupe[zauzeto];
                q.emplace(make_pair(ni, nj));
            }
        }
    }
}
int main() {
    cin >> n;
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j)
            cin >> h[i][j];
    }
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j)
            cin >> v[i][j];
    }
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            if(!pos[i][j]) {
                pos[i][j] = true;
                g[i][j] = zauzeto;
                q.emplace(make_pair(i, j));
                clanovaGrupe[zauzeto]++;
                grupe();
                ++zauzeto;
            }
        }
    }
    ll maxGrupa = 0;
    for(int i = 1; i <= 10000000; i++) {
        if(clanovaGrupe[i] > maxGrupa)
        maxGrupa = clanovaGrupe[i];
    }
    cout << maxGrupa;
}