#include<bits/stdc++.h>
using namespace std;

const int N = 5e5;
const int mod = 1e9;
typedef long long ll;

struct seg {
    int mini;
    int maxi;
} st[2*N];
int n;
ll suma;

void update(int l, int d, int i, int idx, int vr) {
    if(l == d) {
        st[idx].mini = vr;
        st[idx].maxi = vr;
        return;
    }
    int m = l + (d - l) / 2;
    if(i <= m) {
        update(l, m, i, 2 * idx, vr);
    }
    else {
        update(m + 1, d, i, 2 * idx + 1, vr);
    }
    st[idx].maxi = max(st[2*idx].maxi, st[2*idx + 1].maxi);
    st[idx].mini = min(st[2*idx].mini, st[2*idx + 1].mini);

}
seg query(int x, int y, int l, int d, int idx) {
    if(x <= l && d <= y) {
        seg nesto;
        nesto.maxi = st[idx].maxi;
        nesto.mini = st[idx].mini;
        return nesto;
    }
    int m = l + (d - l) / 2;
    seg res;
    res.maxi = 0;
    res.mini = 2e9;
    if(x <= m) {
        seg nesto = query(x, y, l, m, 2*idx);
        res.maxi = max(res.maxi, nesto.maxi);
        res.mini = min(res.mini, nesto.mini);
    }
    if(y > m) {
        seg nesto = query(x, y, m + 1, d, 2*idx + 1);
        res.maxi = max(res.maxi, nesto.maxi);
        res.mini = min(res.mini, nesto.mini);
    }
    return res;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n;
    for(int i = 1; i <= n; ++i) {
        int x; cin >> x;
        update(1, N, i, 1, x);
    }
    for(int i = 1; i <= n; ++i) {
        for(int j = i; j <= n; ++j) {
            seg t = query(i, j, 1, N, 1);
            ll maxi = (ll) t.maxi;
            ll mini = (ll) t.mini;

            suma += maxi * mini % mod * (j - i + 1) % mod;
        }
    }
    cout << suma;
}