#include <iostream>
#include <queue>
#include <vector>
#include <algorithm>

#define CTASK tasks.top()

using namespace std;

class soba{
public:
    bool exit;
    vector<int> hodnici;
    void zavrsi();
    void dodajHodnik(int soba2);
};

int dfs(vector<soba>& vec, int begin, int k);

int main()
{
    int n, m, e, k;
    int a, b;
    cin >> n >> m;
    vector<soba> bunker(n);
    for(int i = 0; i < m; ++i){
        cin >> a >> b;
        bunker[a].dodajHodnik(b);
        bunker[b].dodajHodnik(a);
    }
    for(int i = 0; i < n; ++i){
        bunker[i].zavrsi();
    }
    cin >> e;
    for(int i = 0 ; i < e; ++i){
        cin >> a;
        bunker[a].exit = true;
    }
    cin >> k;
    for(int i = 0; i < n; ++i){
        cout << dfs(bunker, i, k) << endl;
    }
    return 0;
}

void soba::zavrsi(){
    sort(hodnici.begin(), hodnici.end());
    exit = false;
}

void soba::dodajHodnik(int soba2){
    hodnici.push_back(soba2);
}

int dfs(vector<soba>& vec, int begin, int k){
    queue<int> tasks;
    //cout << "dfs" << begin << ": started working;\n";
    int ctask;
    int brh;
    tasks.push(begin);
    while(tasks.size() > 0){
        ctask = tasks.front();
        //cout << "dfs" << begin << ".ctask = " << ctask << ";\n";
        if(vec[ctask].exit){
            if(k == 0){
                return ctask;
            }
            else{
                --k;
            }
        }
        brh = vec[ctask].hodnici.size();
        for(int i = 0; i < brh; ++i){
            tasks.push(vec[ctask].hodnici[i]);
        }
        tasks.pop();
    }
    return -1;
}